<?php
// ----------------------------------------------------------------------
// phpNewsfork - Version 0.2
// http://www.borho.net/news/
// (c) 2001-2002 Martin Borho (martin@borho.net)
//
// LICENSE
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
class syndic8 {

 /*
 function:          getNavHTML
 description:      builds the HTML for the navigation
 */
 function getNavHTML($values, $pattern, $syn8_lang, $mode) {

     if ($values[prev_arrow]) {
          $navList = "<a href=\"syndic8.php?pattern=$pattern&startItem=$values[previous]&syn8_lang=$syn8_lang&mode=$mode\">&lt;&lt;&lt; &nbsp;</a>";
     }
     if ($values[steps] > 1) {
          for ($i = "1"; $i <= $values[steps]; $i++) {
               $targetStep = $i * 40 - 40;
               if ($targetStep != $values[startItem]) {
                    $navList .= " <a href=\"syndic8.php?pattern=$pattern&startItem=$targetStep&syn8_lang=$syn8_lang&mode=$mode\">&lt;$i&gt;</a>";
               } else {
                    $navList .= " <a href=\"syndic8.php?pattern=$pattern&startItem=$targetStep&syn8_lang=$syn8_lang&mode=$mode\"><font color=\"red\">&lt;$i&gt;</font></a>";
               }
          }
     }
     if ($values[fwd] == "true") {
          $navList .= " <a href=\"syndic8.php?pattern=$pattern&startItem=$values[endItem]&syn8_lang=$syn8_lang&mode=$mode\">&nbsp; &gt;&gt;&gt;</a>";
     }
  return $navList;
 }

 /*
 function:          getSyndic8Nav
 description:      defines some values for the navigation
 */
 function getSyndic8Nav($startItem, $sumChannels) {
  // if it's not the first interval...
    if ($startItem >= "40") {
        $result[previous] = $startItem - 40;
        $result[prev_arrow] = TRUE;
    } else {
        $result[prev_arrow] = FALSE;
    }
    // define the enditem of the interval and check if's not above
    $endItem = $startItem + 40;
    if ($endItem > $sumChannels) {
        $result[endItem] = $sumChannels;
    } else {
        $result[endItem] = $endItem;
        $result[fwd] = TRUE;
    }
    // how many intervals in the navigation?
    $steps = $sumChannels / 40;
    settype($steps, "integer");
    $result[steps] = $steps + 1;

    $result[startItem] = $startItem;

   return $result;
 }

  /*
  function:          compareSyndic8
  description:      compares two arrays containing Newschannel-sIDs in two possible modes
  */
  function compareSyndic8($array_pre, $array_now, $mode) {

        if ($mode == "add") {
        // add both arrays to one
        foreach ($array_now as $key => $value) {
                if (!in_array($value, $array_pre)) $array_pre[] = $value;
        }
        $result = $array_pre;
        } elseif ($mode == "extract") {
                // extract hits with the right language
                foreach ($array_now as $key => $value) {
                        if (in_array($value, $array_pre)) $array[] = $value;
                }
           $result = $array;
        }
     return $result;
  }

  /*
  function:          getSyndic8Response
  description:      makes a XML-RPC-Request and returns a PHP-native array
  */
  function getSyndic8Response($msg) {

        $client = new xmlrpc_client("/xmlrpc.php", "www.syndic8.com", 80);
        // send a request with the message
        $response=$client->send($msg);
        // get xmlrpcvals
        $values=$response->value();
        if (!$response->faultCode()) {
                // get an PHP-native array
                $result = xmlrpcDecode($values);
        } else {
                die("<b>Error-Code: </b>".$response->faultCode()."<br><b>Error-String: </b>".$response->faultString());
        }
     return $result;
  }

  /*
  function:          getSyndic8
  description:      makes the necessary requests and returns all needed content to syndic8.php
  */
  function getSyndic8($pattern, $lang, $startItem, $mode) {

        // at first for sitename a single request
        $msg=new xmlrpcmsg('syndic8.QueryFeeds', array(new xmlrpcval("sitename", "string"), new xmlrpcval("regexp", "string"), new xmlrpcval("$pattern", "string")));
        $array_name = $this->getSyndic8Response($msg);

        // for description a single request
        $msg=new xmlrpcmsg('syndic8.QueryFeeds', array(new xmlrpcval("description", "string"), new xmlrpcval("regexp", "string"), new xmlrpcval("$pattern", "string")));
        $array_desc = $this->getSyndic8Response($msg);

        // compare the hits for both requests
        $channels = $this->compareSyndic8($array_name, $array_desc, "add");

        if ($lang != "all") {
                //if $lang is specified, make a request
                $msg=new xmlrpcmsg('syndic8.QueryFeeds', array(new xmlrpcval("lang_code", "string"), new xmlrpcval("like", "string"), new xmlrpcval("$lang", "string")));
                $array_lang = $this->getSyndic8Response($msg);
                // compare all hits and extract the IDs for the language
                $channels = $this->compareSyndic8($channels, $array_lang, "extract");
        }

        // get the number of intervals the range of hits
        $nav_values = $this->getSyndic8Nav($startItem, count($channels));
        // get the HTMl-navigation
        $result[nav] = $this->getNavHTML($nav_values, $pattern, $lang, $mode);
        // make an array of the intervall to display
        for ($i = $startItem; $i < $nav_values[endItem]; $i++) {
                $adding[] = new xmlrpcval("$channels[$i]", "int");
        }

        $fields = array(
                        new xmlrpcval("sitename", "string"),
                        new xmlrpcval("dataurl", "string"),
                        new xmlrpcval("description", "string"),
                        new xmlrpcval("status", "string"),
                        new xmlrpcval("rss_version", "string")
                        );
        // get the feed informations for the feeds with the specified fields
        $msg=new xmlrpcmsg('syndic8.GetFeedInfo', array(new xmlrpcval($adding, "array"), new xmlrpcval($fields, "array")));
        $result[channels] = $this->getSyndic8Response($msg);

      return $result;
  }


  /*
  function:          load_ext_file
  description:      get a rss-file from the url
  */
  function load_ext_file ( $url ) {
        // Check whether the file exists and is readable.
        if ($url != "" ) {
            // Read the content of the file.
            if ($fh = @fopen("$url","r")) {
                while ($line = fgets($fh,1000000)) {
                $file .= $line;
                }
            fclose($fh);
            }
        }
     return $file;
  }

}
?>
